package jp.sourceforge.tsukuyomi.openid.rp;

import jp.sourceforge.tsukuyomi.openid.OpenIDException;
import jp.sourceforge.tsukuyomi.openid.discovery.impl.DiscoveryImpl;
import jp.sourceforge.tsukuyomi.openid.discovery.impl.HtmlResolverImpl;
import jp.sourceforge.tsukuyomi.openid.http.impl.HttpClientManagerImpl;
import jp.sourceforge.tsukuyomi.openid.op.impl.IncrementalNonceGenerator;
import jp.sourceforge.tsukuyomi.openid.rp.impl.InMemoryConsumerAssociationStore;
import jp.sourceforge.tsukuyomi.openid.rp.impl.InMemoryNonceVerifier;
import jp.sourceforge.tsukuyomi.openid.rp.impl.RelayPartyImpl;
import jp.sourceforge.tsukuyomi.openid.yadis.impl.YadisResolverImpl;

public class RelayPartyFactory {
	public static RelayParty getInstance() throws OpenIDException {
		HttpClientManagerImpl hcm = new HttpClientManagerImpl();
		DiscoveryImpl discovery = new DiscoveryImpl();
		HtmlResolverImpl hr = new HtmlResolverImpl();
		YadisResolverImpl yr = new YadisResolverImpl();
		RelayPartyImpl rp = new RelayPartyImpl();
		IncrementalNonceGenerator ing = new IncrementalNonceGenerator();
		InMemoryNonceVerifier imnv = new InMemoryNonceVerifier(60);
		InMemoryConsumerAssociationStore imcas =
			new InMemoryConsumerAssociationStore();

		hr.setHttpClientManager(hcm);
		yr.setHttpClientManager(hcm);
		discovery.setHtmlResolver(hr);
		discovery.setYadisResolver(yr);

		rp.setDiscovery(discovery);
		rp.setConsumerNonceGenerator(ing);
		rp.setNonceVerifier(imnv);
		rp.setAssociations(imcas);

		return rp;
	}
}
